Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.apache.commons.collections.collection
Class PredicatedCollection

    java.lang.Object
      org.apache.commons.collections.collection.AbstractCollectionDecorator
          org.apache.commons.collections.collection.AbstractSerializableCollectionDecorator
              org.apache.commons.collections.collection.PredicatedCollection

All Implemented Interfaces:
  java.io.Serializable, java.lang.Iterable, java.util.Collection

Direct Known Subclasses:
  PredicatedBag, PredicatedBuffer, PredicatedList, PredicatedSet

    public class PredicatedCollection

extends AbstractSerializableCollectionDecorator

Decorates another `Collection` to validate that additions match a specified predicate.

This collection exists to provide validation for the decorated collection. It is normally created to decorate an empty collection. If an object cannot be added to the collection, an IllegalArgumentException is thrown.

One usage would be to ensure that no null entries are added to the collection.

    Collection coll = PredicatedCollection.decorate(new ArrayList(), NotNullPredicate.INSTANCE);

This class is Serializable from Commons Collections 3.1.

Since:
  Commons Collections 3.0
Version:
  $Revision: 646777 $ $Date: 2008-04-10 13:33:15 +0100 (Thu, 10 Apr 2008) $
Author:
  Stephen Colebourne, Paul Jack
See Also:
  Serialized Form

Field Summary
`protected Predicate` | `predicate` The predicate to use

Fields inherited from class org.apache.commons.collections.collection.AbstractCollectionDecorator
`collection`

Constructor Summary
`protected` | `PredicatedCollection(java.util.Collection coll, Predicate predicate)` Constructor that wraps (not copies).

Method Summary
`boolean` | `add(java.lang.Object object)` Override to validate the object being added to ensure it matches the predicate.
`boolean` | `addAll(java.util.Collection coll)` Override to validate the objects being added to ensure they match the predicate.
`static java.util.Collection` | `decorate(java.util.Collection coll, Predicate predicate)` Factory method to create a predicated (validating) collection.
`protected void` | `validate(java.lang.Object object)` Validates the object being added to ensure it matches the predicate.

Methods inherited from class org.apache.commons.collections.collection.AbstractCollectionDecorator
`clear, contains, containsAll, equals, getCollection, hashCode, isEmpty, iterator, remove, removeAll, retainAll, size, toArray, toArray, toString`

Methods inherited from class java.lang.Object
`clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

Field Detail

### predicate

    protected final Predicate predicate

  The predicate to use

Constructor Detail

### PredicatedCollection

    protected PredicatedCollection(java.util.Collection coll,
                                   Predicate predicate)

  Constructor that wraps (not copies).

  If there are any elements already in the collection being decorated, they are validated.

  Parameters:
    `coll` - the collection to decorate, must not be null
    `predicate` - the predicate to use for validation, must not be null
  Throws:
    `java.lang.IllegalArgumentException` - if collection or predicate is null
    `java.lang.IllegalArgumentException` - if the collection contains invalid elements

Method Detail

### decorate

    public static java.util.Collection decorate(java.util.Collection coll,
                                                Predicate predicate)

  Factory method to create a predicated (validating) collection.

  If there are any elements already in the collection being decorated, they are validated.

  Parameters:
    `coll` - the collection to decorate, must not be null
    `predicate` - the predicate to use for validation, must not be null
  Returns:
    a new predicated collection
  Throws:
    `java.lang.IllegalArgumentException` - if collection or predicate is null
    `java.lang.IllegalArgumentException` - if the collection contains invalid elements

### validate

    protected void validate(java.lang.Object object)

  Validates the object being added to ensure it matches the predicate.

  The predicate itself should not throw an exception, but return false to indicate that the object cannot be added.

  Parameters:
    `object` - the object being added
  Throws:
    `java.lang.IllegalArgumentException` - if the add is invalid

### add

    public boolean add(java.lang.Object object)

  Override to validate the object being added to ensure it matches the predicate.

  Specified by:
    `add` in interface `java.util.Collection`
  Overrides:
    `add` in class `AbstractCollectionDecorator`
  Parameters:
    `object` - the object being added
  Returns:
    the result of adding to the underlying collection
  Throws:
    `java.lang.IllegalArgumentException` - if the add is invalid

### addAll

    public boolean addAll(java.util.Collection coll)

  Override to validate the objects being added to ensure they match the predicate. If any one fails, no update is made to the underlying collection.

  Specified by:
    `addAll` in interface `java.util.Collection`
  Overrides:
    `addAll` in class `AbstractCollectionDecorator`
  Parameters:
    `coll` - the collection being added
  Returns:
    the result of adding to the underlying collection
  Throws:
    `java.lang.IllegalArgumentException` - if the add is invalid

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2001-2008 The Apache Software Foundation. All Rights Reserved.